/* WallpaperWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from WallpaperWindow.vala, do not modify */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <adwaita.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gsk/gsk.h>
#include <gtk4-layer-shell.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <stdio.h>
#include <graphene-gobject.h>

#define WALLPAPER_WINDOW_SCALING_FILTER GSK_SCALING_FILTER_NEAREST
#define WALLPAPER_WINDOW_TRANSITION_DURATION 500
#define WALLPAPER_WINDOW_BLUR_RADIUS 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WALLPAPER_TYPE_WINDOW (wallpaper_window_get_type ())
#define WALLPAPER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WALLPAPER_TYPE_WINDOW, WallpaperWindow))
#define WALLPAPER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WALLPAPER_TYPE_WINDOW, WallpaperWindowClass))
#define WALLPAPER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WALLPAPER_TYPE_WINDOW))
#define WALLPAPER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WALLPAPER_TYPE_WINDOW))
#define WALLPAPER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WALLPAPER_TYPE_WINDOW, WallpaperWindowClass))

typedef struct _WallpaperWindow WallpaperWindow;
typedef struct _WallpaperWindowClass WallpaperWindowClass;
typedef struct _WallpaperWindowPrivate WallpaperWindowPrivate;

#define WALLPAPER_TYPE_BACKGROUND_INFO (wallpaper_background_info_get_type ())
typedef struct _WallpaperBackgroundInfo WallpaperBackgroundInfo;

#define UTILS_TYPE_CONFIG (utils_config_get_type ())
typedef struct _UtilsConfig UtilsConfig;
typedef enum  {
	UTILS_SCALE_MODES_FILL = 0,
	UTILS_SCALE_MODES_STRETCH = 1,
	UTILS_SCALE_MODES_FIT = 2,
	UTILS_SCALE_MODES_CENTER = 3
} UtilsScaleModes;

#define UTILS_TYPE_SCALE_MODES (utils_scale_modes_get_type ())
enum  {
	WALLPAPER_WINDOW_0_PROPERTY,
	WALLPAPER_WINDOW_MONITOR_PROPERTY,
	WALLPAPER_WINDOW_NUM_PROPERTIES
};
static GParamSpec* wallpaper_window_properties[WALLPAPER_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _wallpaper_background_info_free0(var) ((var == NULL) ? NULL : (var = (wallpaper_background_info_free (var), NULL)))
#define _utils_config_free0(var) ((var == NULL) ? NULL : (var = (utils_config_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _WallpaperWindowChangeWallpaperData WallpaperWindowChangeWallpaperData;

struct _WallpaperWindow {
	GtkWindow parent_instance;
	WallpaperWindowPrivate * priv;
};

struct _WallpaperWindowClass {
	GtkWindowClass parent_class;
};

struct _UtilsConfig {
	gchar* path;
	UtilsScaleModes scale_mode;
	gchar* color;
};

struct _WallpaperBackgroundInfo {
	UtilsConfig config;
	GdkTexture* texture;
	gint width;
	gint height;
	guint file_hash;
};

struct _WallpaperWindowPrivate {
	GdkMonitor* _monitor;
	gdouble animation_progress;
	AdwTimedAnimation* animation;
	gboolean loading_texture;
	GCancellable* pixbuf_cancellable;
	WallpaperBackgroundInfo* background_info;
	WallpaperBackgroundInfo* old_background_info;
};

struct _WallpaperWindowChangeWallpaperData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WallpaperWindow* self;
	UtilsConfig config;
	WallpaperBackgroundInfo* _tmp0_;
	WallpaperBackgroundInfo* _tmp1_;
	WallpaperBackgroundInfo* _tmp2_;
	WallpaperBackgroundInfo _tmp3_;
	WallpaperBackgroundInfo _tmp4_;
	WallpaperBackgroundInfo* _tmp5_;
	WallpaperBackgroundInfo* _tmp6_;
	UtilsConfig _tmp7_;
	UtilsConfig _tmp8_;
	UtilsConfig _tmp9_;
	gboolean _tmp10_;
	WallpaperBackgroundInfo* _tmp11_;
	UtilsConfig _tmp12_;
	const gchar* _tmp13_;
	WallpaperBackgroundInfo* _tmp14_;
	UtilsConfig _tmp15_;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GCancellable* _tmp19_;
	GCancellable* _tmp20_;
	GFile* file;
	WallpaperBackgroundInfo* _tmp21_;
	UtilsConfig _tmp22_;
	const gchar* _tmp23_;
	GFile* _tmp24_;
	guint hash;
	GFile* _tmp25_;
	gboolean _tmp26_;
	WallpaperBackgroundInfo* _tmp27_;
	WallpaperBackgroundInfo* _tmp28_;
	UtilsConfig* _tmp29_;
	UtilsConfig _tmp30_;
	UtilsConfig _tmp31_;
	UtilsConfig* _tmp32_;
	UtilsConfig* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	WallpaperBackgroundInfo* _tmp36_;
	UtilsConfig _tmp37_;
	const gchar* _tmp38_;
	WallpaperBackgroundInfo* _tmp39_;
	WallpaperBackgroundInfo* _tmp40_;
	guint* _tmp41_;
	guint* _tmp42_;
	GInputStream* stream;
	GFile* _tmp43_;
	GCancellable* _tmp44_;
	GFileInputStream* _tmp45_;
	GdkPixbuf* pixbuf;
	GInputStream* _tmp46_;
	GdkMonitor* _tmp47_;
	GdkRectangle _tmp48_;
	GdkRectangle _tmp49_;
	GdkMonitor* _tmp50_;
	GdkRectangle _tmp51_;
	GdkRectangle _tmp52_;
	GCancellable* _tmp53_;
	GdkPixbuf* _tmp54_;
	WallpaperBackgroundInfo* _tmp55_;
	GdkPixbuf* _tmp56_;
	GdkTexture* _tmp57_;
	WallpaperBackgroundInfo* _tmp58_;
	GdkPixbuf* _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	WallpaperBackgroundInfo* _tmp62_;
	GdkPixbuf* _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	WallpaperBackgroundInfo* _tmp66_;
	GError* e;
	FILE* _tmp67_;
	GError* _tmp68_;
	const gchar* _tmp69_;
	WallpaperBackgroundInfo* _tmp70_;
	WallpaperBackgroundInfo* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	WallpaperBackgroundInfo* _tmp74_;
	WallpaperBackgroundInfo* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	GError* _inner_error0_;
};

static gint WallpaperWindow_private_offset;
static gpointer wallpaper_window_parent_class = NULL;

VALA_EXTERN GType wallpaper_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WallpaperWindow, g_object_unref)
VALA_EXTERN GType wallpaper_background_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType utils_config_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType utils_scale_modes_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UtilsConfig* utils_config_dup (const UtilsConfig* self);
VALA_EXTERN void utils_config_free (UtilsConfig* self);
VALA_EXTERN void utils_config_copy (const UtilsConfig* self,
                        UtilsConfig* dest);
VALA_EXTERN void utils_config_destroy (UtilsConfig* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (UtilsConfig, utils_config_destroy)
VALA_EXTERN WallpaperBackgroundInfo* wallpaper_background_info_dup (const WallpaperBackgroundInfo* self);
VALA_EXTERN void wallpaper_background_info_free (WallpaperBackgroundInfo* self);
VALA_EXTERN void wallpaper_background_info_copy (const WallpaperBackgroundInfo* self,
                                     WallpaperBackgroundInfo* dest);
VALA_EXTERN void wallpaper_background_info_destroy (WallpaperBackgroundInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (WallpaperBackgroundInfo, wallpaper_background_info_destroy)
VALA_EXTERN WallpaperWindow* wallpaper_window_new (GtkApplication* app,
                                       GdkMonitor* monitor);
VALA_EXTERN WallpaperWindow* wallpaper_window_construct (GType object_type,
                                             GtkApplication* app,
                                             GdkMonitor* monitor);
static void wallpaper_window_animation_value_cb (WallpaperWindow* self,
                                          gdouble progress);
static void _wallpaper_window_animation_value_cb_adw_animation_target_func (gdouble value,
                                                                     gpointer self);
static void wallpaper_window_change_wallpaper_data_free (gpointer _data);
VALA_EXTERN void wallpaper_window_change_wallpaper (WallpaperWindow* self,
                                        UtilsConfig* config,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN void wallpaper_window_change_wallpaper_finish (WallpaperWindow* self,
                                               GAsyncResult* _res_);
static gboolean wallpaper_window_change_wallpaper_co (WallpaperWindowChangeWallpaperData* _data_);
static guint* _uint_dup (guint* self);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static void wallpaper_window_change_wallpaper_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
VALA_EXTERN GdkMonitor* wallpaper_window_get_monitor (WallpaperWindow* self);
VALA_EXTERN gchar* wallpaper_background_info_to_string (WallpaperBackgroundInfo *self);
VALA_EXTERN void wallpaper_window_run_animation (WallpaperWindow* self);
static void wallpaper_window_real_snapshot (GtkWidget* base,
                                     GtkSnapshot* snapshot);
static gdouble wallpaper_window_get_animation_progress_inv (WallpaperWindow* self);
static void wallpaper_window_apply_transformed_background (WallpaperWindow* self,
                                                    GtkSnapshot* snapshot,
                                                    WallpaperBackgroundInfo* info);
VALA_EXTERN void utils_config_get_color (UtilsConfig *self,
                             GdkRGBA* result);
static void wallpaper_window_draw_scale_wide (WallpaperWindow* self,
                                       gint buffer_width,
                                       gint width,
                                       gint buffer_height,
                                       gint height,
                                       GtkSnapshot* snapshot,
                                       WallpaperBackgroundInfo* info);
static void wallpaper_window_draw_scale_tall (WallpaperWindow* self,
                                       gint buffer_width,
                                       gint width,
                                       gint buffer_height,
                                       gint height,
                                       GtkSnapshot* snapshot,
                                       WallpaperBackgroundInfo* info);
VALA_EXTERN void wallpaper_window_set_monitor (WallpaperWindow* self,
                                   GdkMonitor* value);
static void wallpaper_window_finalize (GObject * obj);
static GType wallpaper_window_get_type_once (void);
static void _vala_wallpaper_window_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_wallpaper_window_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
wallpaper_window_get_instance_private (WallpaperWindow* self)
{
	return G_STRUCT_MEMBER_P (self, WallpaperWindow_private_offset);
}

static void
_wallpaper_window_animation_value_cb_adw_animation_target_func (gdouble value,
                                                                gpointer self)
{
#line 28 "../src/Wallpaper/WallpaperWindow.vala"
	wallpaper_window_animation_value_cb ((WallpaperWindow*) self, value);
#line 299 "WallpaperWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/Wallpaper/WallpaperWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 307 "WallpaperWindow.c"
}

WallpaperWindow*
wallpaper_window_construct (GType object_type,
                            GtkApplication* app,
                            GdkMonitor* monitor)
{
	WallpaperWindow * self = NULL;
	AdwCallbackAnimationTarget* target = NULL;
	AdwCallbackAnimationTarget* _tmp0_;
	AdwAnimationTarget* _tmp1_;
	AdwTimedAnimation* _tmp2_;
#line 22 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 22 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_val_if_fail (monitor != NULL, NULL);
#line 23 "../src/Wallpaper/WallpaperWindow.vala"
	self = (WallpaperWindow*) g_object_new (object_type, "application", app, "monitor", monitor, NULL);
#line 28 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = (AdwCallbackAnimationTarget*) adw_callback_animation_target_new (_wallpaper_window_animation_value_cb_adw_animation_target_func, g_object_ref (self), g_object_unref);
#line 28 "../src/Wallpaper/WallpaperWindow.vala"
	target = _tmp0_;
#line 29 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = _g_object_ref0 ((AdwAnimationTarget*) target);
#line 29 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_ = (AdwTimedAnimation*) adw_timed_animation_new ((GtkWidget*) self, 1.0, 0.0, (guint) WALLPAPER_WINDOW_TRANSITION_DURATION, _tmp1_);
#line 29 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (self->priv->animation);
#line 29 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->animation = _tmp2_;
#line 31 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_init_for_window ((GtkWindow*) self);
#line 32 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_monitor ((GtkWindow*) self, monitor);
#line 33 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_layer ((GtkWindow*) self, GTK_LAYER_SHELL_LAYER_BACKGROUND);
#line 34 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_exclusive_zone ((GtkWindow*) self, -1);
#line 35 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_TOP, TRUE);
#line 36 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_BOTTOM, TRUE);
#line 37 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_LEFT, TRUE);
#line 38 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_RIGHT, TRUE);
#line 22 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (target);
#line 22 "../src/Wallpaper/WallpaperWindow.vala"
	return self;
#line 358 "WallpaperWindow.c"
}

WallpaperWindow*
wallpaper_window_new (GtkApplication* app,
                      GdkMonitor* monitor)
{
#line 22 "../src/Wallpaper/WallpaperWindow.vala"
	return wallpaper_window_construct (WALLPAPER_TYPE_WINDOW, app, monitor);
#line 367 "WallpaperWindow.c"
}

static void
wallpaper_window_change_wallpaper_data_free (gpointer _data)
{
	WallpaperWindowChangeWallpaperData* _data_;
	_data_ = _data;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	utils_config_destroy (&_data_->config);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (_data_->self);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	g_slice_free (WallpaperWindowChangeWallpaperData, _data_);
#line 381 "WallpaperWindow.c"
}

void
wallpaper_window_change_wallpaper (WallpaperWindow* self,
                                   UtilsConfig* config,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	WallpaperWindowChangeWallpaperData* _data_;
	WallpaperWindow* _tmp0_;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (config != NULL);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	_data_ = g_slice_new0 (WallpaperWindowChangeWallpaperData);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wallpaper_window_change_wallpaper_data_free);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->self = _tmp0_;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	utils_config_destroy (&_data_->config);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->config = *config;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	wallpaper_window_change_wallpaper_co (_data_);
#line 412 "WallpaperWindow.c"
}

void
wallpaper_window_change_wallpaper_finish (WallpaperWindow* self,
                                          GAsyncResult* _res_)
{
	WallpaperWindowChangeWallpaperData* _data_;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 422 "WallpaperWindow.c"
}

static gpointer
_wallpaper_background_info_dup0 (gpointer self)
{
#line 44 "../src/Wallpaper/WallpaperWindow.vala"
	return self ? wallpaper_background_info_dup (self) : NULL;
#line 430 "WallpaperWindow.c"
}

static gpointer
_utils_config_dup0 (gpointer self)
{
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
	return self ? utils_config_dup (self) : NULL;
#line 438 "WallpaperWindow.c"
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	dup = g_new0 (guint, 1);
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	memcpy (dup, self, sizeof (guint));
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	return dup;
#line 451 "WallpaperWindow.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	return self ? _uint_dup (self) : NULL;
#line 459 "WallpaperWindow.c"
}

static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	if (s1 == s2) {
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
		return TRUE;
#line 470 "WallpaperWindow.c"
	}
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	if (s1 == NULL) {
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
		return FALSE;
#line 476 "WallpaperWindow.c"
	}
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	if (s2 == NULL) {
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
		return FALSE;
#line 482 "WallpaperWindow.c"
	}
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
	return (*s1) == (*s2);
#line 486 "WallpaperWindow.c"
}

static void
wallpaper_window_change_wallpaper_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	WallpaperWindowChangeWallpaperData* _data_;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
	_data_ = _user_data_;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_source_object_ = source_object;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_res_ = _res_;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
	wallpaper_window_change_wallpaper_co (_data_);
#line 503 "WallpaperWindow.c"
}

static gboolean
wallpaper_window_change_wallpaper_co (WallpaperWindowChangeWallpaperData* _data_)
{
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	switch (_data_->_state_) {
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
		case 0:
#line 513 "WallpaperWindow.c"
		goto _state_0;
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
		case 1:
#line 517 "WallpaperWindow.c"
		goto _state_1;
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
		case 2:
#line 521 "WallpaperWindow.c"
		goto _state_2;
		default:
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
		g_assert_not_reached ();
#line 526 "WallpaperWindow.c"
	}
	_state_0:
#line 42 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->self->priv->loading_texture = TRUE;
#line 44 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp0_ = _data_->self->priv->background_info;
#line 44 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp1_ = _wallpaper_background_info_dup0 (_data_->_tmp0_);
#line 44 "../src/Wallpaper/WallpaperWindow.vala"
	_wallpaper_background_info_free0 (_data_->self->priv->old_background_info);
#line 44 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->self->priv->old_background_info = _data_->_tmp1_;
#line 45 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp2_ = _data_->self->priv->background_info;
#line 45 "../src/Wallpaper/WallpaperWindow.vala"
	if (_data_->_tmp2_ == NULL) {
#line 46 "../src/Wallpaper/WallpaperWindow.vala"
		memset (&_data_->_tmp3_, 0, sizeof (WallpaperBackgroundInfo));
#line 46 "../src/Wallpaper/WallpaperWindow.vala"
		memset (&_data_->_tmp3_, 0, sizeof (WallpaperBackgroundInfo));
#line 46 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 46 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp5_ = _wallpaper_background_info_dup0 (&_data_->_tmp4_);
#line 46 "../src/Wallpaper/WallpaperWindow.vala"
		_wallpaper_background_info_free0 (_data_->self->priv->background_info);
#line 46 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->self->priv->background_info = _data_->_tmp5_;
#line 46 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_background_info_destroy (&_data_->_tmp4_);
#line 557 "WallpaperWindow.c"
	}
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp6_ = _data_->self->priv->background_info;
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp7_ = _data_->config;
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	memset (&_data_->_tmp9_, 0, sizeof (UtilsConfig));
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	utils_config_copy (&_data_->_tmp8_, &_data_->_tmp9_);
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	utils_config_destroy (&(*_data_->_tmp6_).config);
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	(*_data_->_tmp6_).config = _data_->_tmp9_;
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp11_ = _data_->self->priv->background_info;
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp12_ = (*_data_->_tmp11_).config;
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp13_ = _data_->_tmp12_.path;
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
	if (_data_->_tmp13_ != NULL) {
#line 51 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp14_ = _data_->self->priv->background_info;
#line 51 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp15_ = (*_data_->_tmp14_).config;
#line 51 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp16_ = _data_->_tmp15_.path;
#line 51 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp17_ = strlen (_data_->_tmp16_);
#line 51 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 51 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp10_ = _data_->_tmp18_ > 0;
#line 593 "WallpaperWindow.c"
	} else {
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp10_ = FALSE;
#line 597 "WallpaperWindow.c"
	}
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
	if (_data_->_tmp10_) {
#line 53 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp19_ = _data_->self->priv->pixbuf_cancellable;
#line 53 "../src/Wallpaper/WallpaperWindow.vala"
		g_cancellable_cancel (_data_->_tmp19_);
#line 54 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp20_ = _data_->self->priv->pixbuf_cancellable;
#line 54 "../src/Wallpaper/WallpaperWindow.vala"
		g_cancellable_reset (_data_->_tmp20_);
#line 609 "WallpaperWindow.c"
		{
#line 57 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp21_ = _data_->self->priv->background_info;
#line 57 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp22_ = (*_data_->_tmp21_).config;
#line 57 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp23_ = _data_->_tmp22_.path;
#line 57 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp24_ = g_file_new_for_path (_data_->_tmp23_);
#line 57 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->file = _data_->_tmp24_;
#line 58 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp25_ = _data_->file;
#line 58 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->hash = g_file_hash (_data_->_tmp25_);
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp28_ = _data_->self->priv->old_background_info;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp27_ = _data_->_tmp28_;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp29_ = NULL;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			if (_data_->_tmp27_ != NULL) {
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp30_ = (*_data_->_tmp27_).config;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp31_ = _data_->_tmp30_;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp32_ = _utils_config_dup0 (&_data_->_tmp31_);
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_utils_config_free0 (_data_->_tmp29_);
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp29_ = _data_->_tmp32_;
#line 643 "WallpaperWindow.c"
			}
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp33_ = _data_->_tmp29_;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp34_ = NULL;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			if (_data_->_tmp33_ != NULL) {
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp35_ = (*_data_->_tmp33_).path;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp34_ = _data_->_tmp35_;
#line 655 "WallpaperWindow.c"
			}
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp36_ = _data_->self->priv->background_info;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp37_ = (*_data_->_tmp36_).config;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp38_ = _data_->_tmp37_.path;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			if (g_strcmp0 (_data_->_tmp34_, _data_->_tmp38_) == 0) {
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp40_ = _data_->self->priv->old_background_info;
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp39_ = _data_->_tmp40_;
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp41_ = NULL;
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
				if (_data_->_tmp39_ != NULL) {
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
					_data_->_tmp42_ = __uint_dup0 (&(*_data_->_tmp39_).file_hash);
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
					_g_free0 (_data_->_tmp41_);
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
					_data_->_tmp41_ = _data_->_tmp42_;
#line 679 "WallpaperWindow.c"
				}
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp26_ = _uint_equal (_data_->_tmp41_, &_data_->hash) == TRUE;
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_g_free0 (_data_->_tmp41_);
#line 685 "WallpaperWindow.c"
			} else {
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
				_data_->_tmp26_ = FALSE;
#line 689 "WallpaperWindow.c"
			}
#line 59 "../src/Wallpaper/WallpaperWindow.vala"
			if (_data_->_tmp26_) {
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
				_utils_config_free0 (_data_->_tmp29_);
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
				_g_object_unref0 (_data_->file);
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
				utils_config_destroy (&_data_->config);
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
				if (_data_->_state_ != 0) {
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 707 "WallpaperWindow.c"
					}
				}
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
				g_object_unref (_data_->_async_result);
#line 61 "../src/Wallpaper/WallpaperWindow.vala"
				return FALSE;
#line 714 "WallpaperWindow.c"
			}
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp43_ = _data_->file;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp44_ = _data_->self->priv->pixbuf_cancellable;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_state_ = 1;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			g_file_read_async (_data_->_tmp43_, G_PRIORITY_DEFAULT, _data_->_tmp44_, wallpaper_window_change_wallpaper_ready, _data_);
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			return FALSE;
#line 726 "WallpaperWindow.c"
			_state_1:
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp45_ = g_file_read_finish (_data_->_tmp43_, _data_->_res_, &_data_->_inner_error0_);
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->stream = (GInputStream*) _data_->_tmp45_;
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
				_utils_config_free0 (_data_->_tmp29_);
#line 63 "../src/Wallpaper/WallpaperWindow.vala"
				_g_object_unref0 (_data_->file);
#line 738 "WallpaperWindow.c"
				goto __catch0_g_error;
			}
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp46_ = _data_->stream;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp47_ = _data_->self->priv->_monitor;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			memset (&_data_->_tmp48_, 0, sizeof (GdkRectangle));
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			gdk_monitor_get_geometry (_data_->_tmp47_, &_data_->_tmp48_);
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp49_ = _data_->_tmp48_;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp50_ = _data_->self->priv->_monitor;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			memset (&_data_->_tmp51_, 0, sizeof (GdkRectangle));
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			gdk_monitor_get_geometry (_data_->_tmp50_, &_data_->_tmp51_);
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp52_ = _data_->_tmp51_;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp53_ = _data_->self->priv->pixbuf_cancellable;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_state_ = 2;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			gdk_pixbuf_new_from_stream_at_scale_async (_data_->_tmp46_, _data_->_tmp49_.width, _data_->_tmp52_.height, TRUE, _data_->_tmp53_, wallpaper_window_change_wallpaper_ready, _data_);
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			return FALSE;
#line 767 "WallpaperWindow.c"
			_state_2:
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp54_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->pixbuf = _data_->_tmp54_;
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
				_g_object_unref0 (_data_->stream);
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
				_utils_config_free0 (_data_->_tmp29_);
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
				_g_object_unref0 (_data_->file);
#line 781 "WallpaperWindow.c"
				goto __catch0_g_error;
			}
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp55_ = _data_->self->priv->background_info;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp56_ = _data_->pixbuf;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp57_ = gdk_texture_new_for_pixbuf (_data_->_tmp56_);
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
			_g_object_unref0 ((*_data_->_tmp55_).texture);
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
			(*_data_->_tmp55_).texture = _data_->_tmp57_;
#line 70 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp58_ = _data_->self->priv->background_info;
#line 70 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp59_ = _data_->pixbuf;
#line 70 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp60_ = gdk_pixbuf_get_width (_data_->_tmp59_);
#line 70 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp61_ = _data_->_tmp60_;
#line 70 "../src/Wallpaper/WallpaperWindow.vala"
			(*_data_->_tmp58_).width = _data_->_tmp61_;
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp62_ = _data_->self->priv->background_info;
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp63_ = _data_->pixbuf;
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp64_ = gdk_pixbuf_get_height (_data_->_tmp63_);
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp65_ = _data_->_tmp64_;
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
			(*_data_->_tmp62_).height = _data_->_tmp65_;
#line 72 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp66_ = _data_->self->priv->background_info;
#line 72 "../src/Wallpaper/WallpaperWindow.vala"
			(*_data_->_tmp66_).file_hash = _data_->hash;
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			_g_object_unref0 (_data_->pixbuf);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			_g_object_unref0 (_data_->stream);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			_utils_config_free0 (_data_->_tmp29_);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			_g_object_unref0 (_data_->file);
#line 826 "WallpaperWindow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->e = _data_->_inner_error0_;
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_inner_error0_ = NULL;
#line 74 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp67_ = stderr;
#line 74 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp68_ = _data_->e;
#line 74 "../src/Wallpaper/WallpaperWindow.vala"
			_data_->_tmp69_ = _data_->_tmp68_->message;
#line 74 "../src/Wallpaper/WallpaperWindow.vala"
			fprintf (_data_->_tmp67_, "Setting wallpaper error: %s\n", _data_->_tmp69_);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			_g_error_free0 (_data_->e);
#line 845 "WallpaperWindow.c"
		}
		__finally0:
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			utils_config_destroy (&_data_->config);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			g_object_unref (_data_->_async_result);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
			return FALSE;
#line 860 "WallpaperWindow.c"
		}
	}
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp71_ = _data_->self->priv->old_background_info;
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp70_ = _data_->_tmp71_;
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp72_ = NULL;
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
	if (_data_->_tmp70_ != NULL) {
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp73_ = wallpaper_background_info_to_string (_data_->_tmp70_);
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
		_g_free0 (_data_->_tmp72_);
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp72_ = _data_->_tmp73_;
#line 877 "WallpaperWindow.c"
	}
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
	g_debug ("WallpaperWindow.vala:78: Old background: %s\n", _data_->_tmp72_);
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp75_ = _data_->self->priv->background_info;
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp74_ = _data_->_tmp75_;
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
	_data_->_tmp76_ = NULL;
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
	if (_data_->_tmp74_ != NULL) {
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp77_ = wallpaper_background_info_to_string (_data_->_tmp74_);
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
		_g_free0 (_data_->_tmp76_);
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
		_data_->_tmp76_ = _data_->_tmp77_;
#line 895 "WallpaperWindow.c"
	}
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
	g_debug ("WallpaperWindow.vala:79: New background: %s\n", _data_->_tmp76_);
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	_g_free0 (_data_->_tmp76_);
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	_g_free0 (_data_->_tmp72_);
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	utils_config_destroy (&_data_->config);
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	if (_data_->_state_ != 0) {
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 913 "WallpaperWindow.c"
		}
	}
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	g_object_unref (_data_->_async_result);
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	return FALSE;
#line 920 "WallpaperWindow.c"
}

void
wallpaper_window_run_animation (WallpaperWindow* self)
{
	AdwTimedAnimation* _tmp0_;
	AdwTimedAnimation* _tmp1_;
#line 83 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->loading_texture = FALSE;
#line 87 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = self->priv->animation;
#line 87 "../src/Wallpaper/WallpaperWindow.vala"
	adw_timed_animation_set_value_to (_tmp0_, (gdouble) 0);
#line 88 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = self->priv->animation;
#line 88 "../src/Wallpaper/WallpaperWindow.vala"
	adw_animation_play ((AdwAnimation*) _tmp1_);
#line 940 "WallpaperWindow.c"
}

static void
wallpaper_window_real_snapshot (GtkWidget* base,
                                GtkSnapshot* snapshot)
{
	WallpaperWindow * self;
	GdkRGBA bg_color = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA _tmp1_;
	graphene_rect_t _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
	WallpaperBackgroundInfo* _tmp4_;
	gboolean _tmp5_ = FALSE;
	AdwTimedAnimation* _tmp6_;
	AdwAnimationState _tmp7_;
	AdwAnimationState _tmp8_;
#line 91 "../src/Wallpaper/WallpaperWindow.vala"
	self = (WallpaperWindow*) base;
#line 91 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 93 "../src/Wallpaper/WallpaperWindow.vala"
	memset (&_tmp0_, 0, sizeof (GdkRGBA));
#line 93 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.red = 0.0f;
#line 93 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.green = 0.0f;
#line 93 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.blue = 0.0f;
#line 93 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.alpha = 1.0f;
#line 93 "../src/Wallpaper/WallpaperWindow.vala"
	bg_color = _tmp0_;
#line 100 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = bg_color;
#line 100 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.origin = (graphene_point_t) {(gfloat) 0, (gfloat) 0};
#line 100 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.size = (graphene_size_t) {(gfloat) gtk_widget_get_width ((GtkWidget*) self), (gfloat) gtk_widget_get_height ((GtkWidget*) self)};
#line 100 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_append_color (snapshot, &_tmp1_, &_tmp2_);
#line 102 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp4_ = self->priv->background_info;
#line 102 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp4_ == NULL) {
#line 102 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp3_ = TRUE;
#line 988 "WallpaperWindow.c"
	} else {
#line 102 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp3_ = self->priv->loading_texture;
#line 992 "WallpaperWindow.c"
	}
#line 102 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp3_) {
#line 103 "../src/Wallpaper/WallpaperWindow.vala"
		return;
#line 998 "WallpaperWindow.c"
	}
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp6_ = self->priv->animation;
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp7_ = adw_animation_get_state ((AdwAnimation*) _tmp6_);
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp8_ = _tmp7_;
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp8_ == ADW_ANIMATION_PLAYING) {
#line 1008 "WallpaperWindow.c"
		WallpaperBackgroundInfo* _tmp9_;
#line 107 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp9_ = self->priv->old_background_info;
#line 107 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp5_ = _tmp9_ != NULL;
#line 1014 "WallpaperWindow.c"
	} else {
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp5_ = FALSE;
#line 1018 "WallpaperWindow.c"
	}
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp5_) {
#line 1022 "WallpaperWindow.c"
		gdouble _tmp10_;
		gdouble _tmp11_;
		WallpaperBackgroundInfo* _tmp12_;
		WallpaperBackgroundInfo _tmp13_;
		WallpaperBackgroundInfo* _tmp14_;
		WallpaperBackgroundInfo _tmp15_;
#line 108 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp10_ = wallpaper_window_get_animation_progress_inv (self);
#line 108 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp11_ = _tmp10_;
#line 108 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_push_cross_fade (snapshot, _tmp11_);
#line 110 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp12_ = self->priv->old_background_info;
#line 110 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp13_ = *_tmp12_;
#line 110 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_window_apply_transformed_background (self, snapshot, &_tmp13_);
#line 111 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_pop (snapshot);
#line 113 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_push_blur (snapshot, self->priv->animation_progress * WALLPAPER_WINDOW_BLUR_RADIUS);
#line 114 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp14_ = self->priv->background_info;
#line 114 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp15_ = *_tmp14_;
#line 114 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_window_apply_transformed_background (self, snapshot, &_tmp15_);
#line 115 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_pop (snapshot);
#line 116 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_pop (snapshot);
#line 1055 "WallpaperWindow.c"
	} else {
		WallpaperBackgroundInfo* _tmp16_;
		WallpaperBackgroundInfo _tmp17_;
#line 118 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp16_ = self->priv->background_info;
#line 118 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp17_ = *_tmp16_;
#line 118 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_window_apply_transformed_background (self, snapshot, &_tmp17_);
#line 1065 "WallpaperWindow.c"
	}
}

static void
wallpaper_window_apply_transformed_background (WallpaperWindow* self,
                                               GtkSnapshot* snapshot,
                                               WallpaperBackgroundInfo* info)
{
	gint buffer_height = 0;
	gint buffer_width = 0;
	gboolean _tmp0_ = FALSE;
	WallpaperBackgroundInfo _tmp1_;
	GdkTexture* _tmp2_;
	gint height = 0;
	WallpaperBackgroundInfo _tmp11_;
	gint width = 0;
	WallpaperBackgroundInfo _tmp12_;
	WallpaperBackgroundInfo _tmp13_;
	UtilsConfig _tmp14_;
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (info != NULL);
#line 123 "../src/Wallpaper/WallpaperWindow.vala"
	buffer_height = gtk_widget_get_height ((GtkWidget*) self);
#line 124 "../src/Wallpaper/WallpaperWindow.vala"
	buffer_width = gtk_widget_get_width ((GtkWidget*) self);
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = *info;
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_ = _tmp1_.texture;
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp2_ == NULL) {
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp0_ = TRUE;
#line 1103 "WallpaperWindow.c"
	} else {
		WallpaperBackgroundInfo _tmp3_;
		UtilsConfig _tmp4_;
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp3_ = *info;
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp4_ = _tmp3_.config;
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp5_ = _tmp4_.path;
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp6_ = strlen (_tmp5_);
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp7_ = _tmp6_;
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp0_ = _tmp7_ == 0;
#line 1122 "WallpaperWindow.c"
	}
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp0_) {
#line 1126 "WallpaperWindow.c"
		GdkRGBA color = {0};
		GdkRGBA _tmp8_ = {0};
		GdkRGBA _tmp9_;
		graphene_rect_t _tmp10_ = {0};
#line 128 "../src/Wallpaper/WallpaperWindow.vala"
		utils_config_get_color (&(*info).config, &_tmp8_);
#line 128 "../src/Wallpaper/WallpaperWindow.vala"
		color = _tmp8_;
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp9_ = color;
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp10_.origin = (graphene_point_t) {(gfloat) 0, (gfloat) 0};
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp10_.size = (graphene_size_t) {(gfloat) buffer_width, (gfloat) buffer_height};
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_append_color (snapshot, &_tmp9_, &_tmp10_);
#line 130 "../src/Wallpaper/WallpaperWindow.vala"
		return;
#line 1145 "WallpaperWindow.c"
	}
#line 135 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp11_ = *info;
#line 135 "../src/Wallpaper/WallpaperWindow.vala"
	height = _tmp11_.height;
#line 136 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp12_ = *info;
#line 136 "../src/Wallpaper/WallpaperWindow.vala"
	width = _tmp12_.width;
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp13_ = *info;
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp14_ = _tmp13_.config;
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
	switch (_tmp14_.scale_mode) {
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_FILL:
#line 1163 "WallpaperWindow.c"
		{
			gdouble window_ratio = 0.0;
			gdouble bg_ratio = 0.0;
#line 139 "../src/Wallpaper/WallpaperWindow.vala"
			window_ratio = ((gdouble) buffer_width) / buffer_height;
#line 140 "../src/Wallpaper/WallpaperWindow.vala"
			bg_ratio = (gdouble) (width / height);
#line 141 "../src/Wallpaper/WallpaperWindow.vala"
			if (window_ratio > bg_ratio) {
#line 1173 "WallpaperWindow.c"
				gdouble scale = 0.0;
#line 142 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_width) / width;
#line 143 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * height) < ((gdouble) buffer_height)) {
#line 1179 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp15_;
#line 144 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp15_ = *info;
#line 144 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp15_);
#line 1185 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp16_;
#line 146 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp16_ = *info;
#line 146 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp16_);
#line 1192 "WallpaperWindow.c"
				}
			} else {
				gdouble scale = 0.0;
#line 149 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_height) / height;
#line 150 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * width) < ((gdouble) buffer_width)) {
#line 1200 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp17_;
#line 151 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp17_ = *info;
#line 151 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp17_);
#line 1206 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp18_;
#line 153 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp18_ = *info;
#line 153 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp18_);
#line 1213 "WallpaperWindow.c"
				}
			}
#line 156 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 1218 "WallpaperWindow.c"
		}
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_FIT:
#line 1222 "WallpaperWindow.c"
		{
			gdouble window_ratio = 0.0;
			gdouble bg_ratio = 0.0;
#line 158 "../src/Wallpaper/WallpaperWindow.vala"
			window_ratio = ((gdouble) buffer_width) / buffer_height;
#line 159 "../src/Wallpaper/WallpaperWindow.vala"
			bg_ratio = (gdouble) (width / height);
#line 160 "../src/Wallpaper/WallpaperWindow.vala"
			if (window_ratio > bg_ratio) {
#line 1232 "WallpaperWindow.c"
				gdouble scale = 0.0;
#line 161 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_width) / width;
#line 162 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * height) < ((gdouble) buffer_height)) {
#line 1238 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp19_;
#line 163 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp19_ = *info;
#line 163 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp19_);
#line 1244 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp20_;
#line 165 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp20_ = *info;
#line 165 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp20_);
#line 1251 "WallpaperWindow.c"
				}
			} else {
				gdouble scale = 0.0;
#line 168 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_height) / height;
#line 169 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * width) < ((gdouble) buffer_width)) {
#line 1259 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp21_;
#line 170 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp21_ = *info;
#line 170 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp21_);
#line 1265 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp22_;
#line 172 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp22_ = *info;
#line 172 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp22_);
#line 1272 "WallpaperWindow.c"
				}
			}
#line 175 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 1277 "WallpaperWindow.c"
		}
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_STRETCH:
#line 1281 "WallpaperWindow.c"
		{
			WallpaperBackgroundInfo _tmp23_;
			GdkTexture* _tmp24_;
			graphene_rect_t _tmp25_ = {0};
#line 177 "../src/Wallpaper/WallpaperWindow.vala"
			gtk_snapshot_scale (snapshot, ((gfloat) buffer_width) / width, ((gfloat) buffer_height) / height);
#line 179 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp23_ = *info;
#line 179 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp24_ = _tmp23_.texture;
#line 179 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp25_.origin = (graphene_point_t) {(gfloat) 0, (gfloat) 0};
#line 179 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp25_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 179 "../src/Wallpaper/WallpaperWindow.vala"
			gtk_snapshot_append_scaled_texture (snapshot, _tmp24_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp25_);
#line 182 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 1300 "WallpaperWindow.c"
		}
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_CENTER:
#line 1304 "WallpaperWindow.c"
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			WallpaperBackgroundInfo _tmp26_;
			GdkTexture* _tmp27_;
			graphene_rect_t _tmp28_ = {0};
#line 184 "../src/Wallpaper/WallpaperWindow.vala"
			x = (gfloat) ((buffer_width / 2) - (width / 2));
#line 185 "../src/Wallpaper/WallpaperWindow.vala"
			y = (gfloat) ((buffer_height / 2) - (height / 2));
#line 186 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp26_ = *info;
#line 186 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp27_ = _tmp26_.texture;
#line 186 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp28_.origin = (graphene_point_t) {x, y};
#line 186 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp28_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 186 "../src/Wallpaper/WallpaperWindow.vala"
			gtk_snapshot_append_scaled_texture (snapshot, _tmp27_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp28_);
#line 189 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 1327 "WallpaperWindow.c"
		}
		default:
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
		break;
#line 1332 "WallpaperWindow.c"
	}
}

static void
wallpaper_window_draw_scale_tall (WallpaperWindow* self,
                                  gint buffer_width,
                                  gint width,
                                  gint buffer_height,
                                  gint height,
                                  GtkSnapshot* snapshot,
                                  WallpaperBackgroundInfo* info)
{
	gfloat scale = 0.0F;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	WallpaperBackgroundInfo _tmp0_;
	GdkTexture* _tmp1_;
	graphene_rect_t _tmp2_ = {0};
#line 193 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 193 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (info != NULL);
#line 199 "../src/Wallpaper/WallpaperWindow.vala"
	scale = ((gfloat) buffer_width) / width;
#line 200 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_scale (snapshot, scale, scale);
#line 201 "../src/Wallpaper/WallpaperWindow.vala"
	x = (gfloat) 0;
#line 202 "../src/Wallpaper/WallpaperWindow.vala"
	y = (gfloat) (((buffer_height / 2) / scale) - (height / 2));
#line 203 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = *info;
#line 203 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = _tmp0_.texture;
#line 203 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.origin = (graphene_point_t) {x, y};
#line 203 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 203 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_append_scaled_texture (snapshot, _tmp1_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp2_);
#line 1375 "WallpaperWindow.c"
}

static void
wallpaper_window_draw_scale_wide (WallpaperWindow* self,
                                  gint buffer_width,
                                  gint width,
                                  gint buffer_height,
                                  gint height,
                                  GtkSnapshot* snapshot,
                                  WallpaperBackgroundInfo* info)
{
	gfloat scale = 0.0F;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	WallpaperBackgroundInfo _tmp0_;
	GdkTexture* _tmp1_;
	graphene_rect_t _tmp2_ = {0};
#line 208 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 208 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (info != NULL);
#line 214 "../src/Wallpaper/WallpaperWindow.vala"
	scale = ((gfloat) buffer_height) / height;
#line 215 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_scale (snapshot, scale, scale);
#line 216 "../src/Wallpaper/WallpaperWindow.vala"
	x = (gfloat) (((buffer_width / 2) / scale) - (width / 2));
#line 217 "../src/Wallpaper/WallpaperWindow.vala"
	y = (gfloat) 0;
#line 218 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = *info;
#line 218 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = _tmp0_.texture;
#line 218 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.origin = (graphene_point_t) {x, y};
#line 218 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 218 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_append_scaled_texture (snapshot, _tmp1_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp2_);
#line 1417 "WallpaperWindow.c"
}

static void
wallpaper_window_animation_value_cb (WallpaperWindow* self,
                                     gdouble progress)
{
#line 223 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->animation_progress = progress;
#line 226 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1430 "WallpaperWindow.c"
}

GdkMonitor*
wallpaper_window_get_monitor (WallpaperWindow* self)
{
	GdkMonitor* result;
	GdkMonitor* _tmp0_;
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = self->priv->_monitor;
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	result = _tmp0_;
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	return result;
#line 1446 "WallpaperWindow.c"
}

void
wallpaper_window_set_monitor (WallpaperWindow* self,
                              GdkMonitor* value)
{
	GdkMonitor* old_value;
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	old_value = wallpaper_window_get_monitor (self);
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	if (old_value != value) {
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
		self->priv->_monitor = value;
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, wallpaper_window_properties[WALLPAPER_WINDOW_MONITOR_PROPERTY]);
#line 1464 "WallpaperWindow.c"
	}
}

static gdouble
wallpaper_window_get_animation_progress_inv (WallpaperWindow* self)
{
	gdouble result;
#line 11 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 12 "../src/Wallpaper/WallpaperWindow.vala"
	result = 1 - self->priv->animation_progress;
#line 12 "../src/Wallpaper/WallpaperWindow.vala"
	return result;
#line 1478 "WallpaperWindow.c"
}

static void
wallpaper_window_class_init (WallpaperWindowClass * klass,
                             gpointer klass_data)
{
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	wallpaper_window_parent_class = g_type_class_peek_parent (klass);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	g_type_class_adjust_private_offset (klass, &WallpaperWindow_private_offset);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	((GtkWidgetClass *) klass)->snapshot = (void (*) (GtkWidget*, GtkSnapshot*)) wallpaper_window_real_snapshot;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wallpaper_window_get_property;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wallpaper_window_set_property;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = wallpaper_window_finalize;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_WINDOW_MONITOR_PROPERTY, wallpaper_window_properties[WALLPAPER_WINDOW_MONITOR_PROPERTY] = g_param_spec_object ("monitor", "monitor", "monitor", gdk_monitor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1499 "WallpaperWindow.c"
}

static void
wallpaper_window_instance_init (WallpaperWindow * self,
                                gpointer klass)
{
	GCancellable* _tmp0_;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv = wallpaper_window_get_instance_private (self);
#line 9 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->animation_progress = 1.0;
#line 16 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->loading_texture = FALSE;
#line 18 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = g_cancellable_new ();
#line 18 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->pixbuf_cancellable = _tmp0_;
#line 19 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->background_info = NULL;
#line 20 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->old_background_info = NULL;
#line 1521 "WallpaperWindow.c"
}

static void
wallpaper_window_finalize (GObject * obj)
{
	WallpaperWindow * self;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLPAPER_TYPE_WINDOW, WallpaperWindow);
#line 15 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (self->priv->animation);
#line 18 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (self->priv->pixbuf_cancellable);
#line 19 "../src/Wallpaper/WallpaperWindow.vala"
	_wallpaper_background_info_free0 (self->priv->background_info);
#line 20 "../src/Wallpaper/WallpaperWindow.vala"
	_wallpaper_background_info_free0 (self->priv->old_background_info);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	G_OBJECT_CLASS (wallpaper_window_parent_class)->finalize (obj);
#line 1540 "WallpaperWindow.c"
}

static GType
wallpaper_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WallpaperWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallpaper_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WallpaperWindow), 0, (GInstanceInitFunc) wallpaper_window_instance_init, NULL };
	GType wallpaper_window_type_id;
	wallpaper_window_type_id = g_type_register_static (gtk_window_get_type (), "WallpaperWindow", &g_define_type_info, 0);
	WallpaperWindow_private_offset = g_type_add_instance_private (wallpaper_window_type_id, sizeof (WallpaperWindowPrivate));
	return wallpaper_window_type_id;
}

GType
wallpaper_window_get_type (void)
{
	static volatile gsize wallpaper_window_type_id__once = 0;
	if (g_once_init_enter (&wallpaper_window_type_id__once)) {
		GType wallpaper_window_type_id;
		wallpaper_window_type_id = wallpaper_window_get_type_once ();
		g_once_init_leave (&wallpaper_window_type_id__once, wallpaper_window_type_id);
	}
	return wallpaper_window_type_id__once;
}

static void
_vala_wallpaper_window_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	WallpaperWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLPAPER_TYPE_WINDOW, WallpaperWindow);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	switch (property_id) {
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		case WALLPAPER_WINDOW_MONITOR_PROPERTY:
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		g_value_set_object (value, wallpaper_window_get_monitor (self));
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		break;
#line 1581 "WallpaperWindow.c"
		default:
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		break;
#line 1587 "WallpaperWindow.c"
	}
}

static void
_vala_wallpaper_window_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	WallpaperWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLPAPER_TYPE_WINDOW, WallpaperWindow);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	switch (property_id) {
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		case WALLPAPER_WINDOW_MONITOR_PROPERTY:
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_window_set_monitor (self, g_value_get_object (value));
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		break;
#line 1607 "WallpaperWindow.c"
		default:
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		break;
#line 1613 "WallpaperWindow.c"
	}
}

